// useful.cpp  ,    
// 2017-06-10

//
//#pragma warning(disable : 4996)
#pragma warning(disable: 4800) // 'int' : forcing value to bool 'true' or 'false'...

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <memory.h>
#include <limits.h>
#include <vector>
using namespace std;

#include "vUtil.h"			//   
#include "iMatrix.h"		//  
#include "iMatrix3.h"		//  3-
#include "pvectors.h"		//      
#include "BiQuadr.h"		//  
#include "vTransf.h"		//  
#include "dMatrix.h"		//  
#include "LeastSq.h"		//   
#include "dfunc1.h"		    // functions of one variable f(x)
#include "dfunc.h"			// functions of n variable f(dvect)
#include "histogram.h"		// 
#include "segment.h"		//   

#include "useful.h"			//  ,    

//-----------------------------------------------------------------------------
// list:=     N*M,   (x0,y0)
void   setListSQ(pvector &list, int x0, int y0, int N, int M)	// list:=   N*M,   (x0,y0)
{
	int y, iy, x, ix;
	list.clear();
	for (y = y0, iy = 0; iy < N; iy++, y += M + 1)
		for (x = x0, ix = 0; ix < N; ix++, x += M + 1)
			list.add(x, y);
}
//-----------------------------------------------------------------------------
void mShift1(matr &src, matr &dst, double vx, double vy)	// dst:= src   (vx,vy)
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
			dst.put(x, y, round(src.getInterp1(x + vx, y + vy)));
}
void mShift3(matr &src, matr &dst, double vx, double vy)	// dst:= src   (vx,vy) 
{
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
			dst.put(x, y, round(src.getInterp3(x + vx, y + vy)));
}
//-----------------------------------------------------------------------------
void mShift1(matr3 &src, matr3 &dst, double vx, double vy)	// dst:= src   (vx,vy)
{
	mShift1(src.r, dst.r, vx, vy);
	mShift1(src.g, dst.g, vx, vy);
	mShift1(src.b, dst.b, vx, vy);
}
void mShift3(matr3 &src, matr3 &dst, double vx, double vy)	// dst:= src   (vx,vy) 
{
	mShift3(src.r, dst.r, vx, vy);
	mShift3(src.g, dst.g, vx, vy);
	mShift3(src.b, dst.b, vx, vy);
}
//-----------------------------------------------------------------------------
void   trApply1(matr  &dst, matr  &src, CvTransf &tr)			// dst:=tr(src) 
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.getInterp1(x1, y1)));
		}
}
void   trApply3(matr  &dst, matr  &src, CvTransf &tr)			// dst:=tr(src) 
{
	if (tr.isNothing()) vError("trApply3: tr is nothing");
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.getInterp3(x1, y1)));
		}
}
//-----------------------------------------------------------------------------
void   trApply1(matr3 &dst, matr3 &src, CvTransf &tr)			// dst:=tr(src) 
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.r.getInterp1(x1, y1)),
				round(src.g.getInterp1(x1, y1)),
				round(src.b.getInterp1(x1, y1)));
		}
}
void   trApply3(matr3 &dst, matr3 &src, CvTransf &tr)			// dst:=tr(src) 
{
	if (tr.isNothing()) vError("trApply3: tr is nothing");
	int mx = src.Mx(), my = src.My();
	dst.setSize(mx, my);
	double x1, y1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			dst.put(x, y, round(src.r.getInterp3(x1, y1)),
				round(src.g.getInterp3(x1, y1)),
				round(src.b.getInterp3(x1, y1)));
		}
}
//-----------------------------------------------------------------------------
double trApply1(matr  &f0, matr  &f1, CvTransf &tr, matr &er)	// er:= tr    
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = f0.Mx(), my = f1.My();
	double S = 0;
	er.setSize(mx, my);
	double x1, y1, er1;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			er1 = fabs(f0(x, y) - f1.getInterp1(x1, y1));
			er(x, y) = round(er1);
			S += er1*er1;
		}
	return sqrt(S / (mx*my));
}
double trApply3(matr  &f0, matr  &f1, CvTransf &tr, matr &er)	// er:= tr    
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = f0.Mx(), my = f1.My();
	er.setSize(mx, my);
	double x1, y1, er1;
	double S = 0;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			er1 = fabs(f0(x, y) - f1.getInterp3(x1, y1));
			er(x, y) = round(er1);
			S += er1*er1;
		}
	return sqrt(S / (mx*my));
}
double trApply1(matr3 &f0, matr3 &f1, CvTransf &tr, matr &er)	// er:= tr    
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = f0.Mx(), my = f1.My();
	er.setSize(mx, my);
	double x1, y1, er1;
	double S = 0;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			er1 = f0.colorDif1(x,y, f1, x1, y1);
			er(x, y) = round(er1);
			S += er1*er1;
		}
	return sqrt(S / (mx*my));
}
double trApply3(matr3 &f0, matr3 &f1, CvTransf &tr, matr &er)	// er:= tr    
{
	if (tr.isNothing()) vError("trApply1: tr is nothing");
	int mx = f0.Mx(), my = f1.My();
	er.setSize(mx, my);
	double x1, y1, er1;
	double S = 0;
	for (int y = 0; y<my; y++)
		for (int x = 0; x<mx; x++)
		{
			tr.apply(x, y, x1, y1); // a(x,y) = (x1,y1)
			er1 = f0.colorDiff(x, y, f1, x1, y1);
			er(x, y) = round(er1);
			S += er1*er1;
		}
	return sqrt(S / (mx*my));
}
//=============================================================================
// ,  S,   ()
//=============================================================================
//double SCo = 1;
//bool isSqrt = true;
//void setMult(double coeff) { SCo = coeff; }	//  ,      S
//void setSqrt(bool sqrt) {isSqrt = sqrt; }	//        S
double retS(double x) {
	return sqrt(x);
//	x *= SCo;
//	return isSqrt ? sqrt(x) : x;
}
//-----------------------------------------------------------------------------
// 2018-03-27   fSi  :
//      (Gvx0, Gvy0)   Gco
//static double Gvx0 = 0, Gvy0 = 0, Gco = 0;
//void   setGSi(double Gvx0_, double Gvy0_, double Gco_)
//{
//	Gvx0 = Gvx0_;
//	Gvy0 = Gvy0_;
//	Gco = Gco_;
//}
//-----------------------------------------------------------------------------
double fSi(matr  &a, matr  &b, int vx, int vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSi: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.safeGet(xa + vx, ya + vy) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fSi(matr3 &a, matr3 &b, int vx, int vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSi: list=0");
	//return fSi(a.r, b.r, vx, vy, list) + fSi(a.g, b.g, vx, vy, list) + fSi(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.safeGet(xa + vx, ya + vy) - a.r.get(xa, ya);
		double s1g = b.g.safeGet(xa + vx, ya + vy) - a.g.get(xa, ya);
		double s1b = b.b.safeGet(xa + vx, ya + vy) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return S;
}
double fSi(matr  &a, matr  &b, int vx, int vy, int x, int y)	// S     
{
	return  iabs(b.safeGet(x + vx, y + vy) - a.get(x, y));
}
double fSi(matr3 &a, matr3 &b, int vx, int vy, int x, int y)	// S     
{
	int s1r = b.r.safeGet(x + vx, y + vy) - a.r.get(x, y);
	int s1g = b.g.safeGet(x + vx, y + vy) - a.g.get(x, y);
	int s1b = b.b.safeGet(x + vx, y + vy) - a.b.get(x, y);
	return (s1r*s1r + s1g*s1g + s1b*s1b);
}
//-----------------------------------------------------------------------------
double fSd1(matr  &a, matr  &b, double vx, double vy, pvector &list)// S       
{
	if (list.size() == 0) vError("fSd1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.getInterp1(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fSd3(matr  &a, matr  &b, double vx, double vy, pvector &list)// S   	 
{
	if (list.size() == 0) vError("fSd3: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1 = b.getInterp3(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fSd1(matr3 &a, matr3 &b, double vx, double vy, pvector &list)// S       
{
	if (list.size() == 0) vError("fSd1: list=0");
	//return fSd1(a.r, b.r, vx, vy, list) + fSd1(a.g, b.g, vx, vy, list) + fSd1(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.getInterp1(xb, yb) - a.r.get(xa, ya);
		double s1g = b.g.getInterp1(xb, yb) - a.g.get(xa, ya);
		double s1b = b.b.getInterp1(xb, yb) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return S;
}
double fSd3(matr3 &a, matr3 &b, double vx, double vy, pvector &list)// S   	 
{
	if (list.size() == 0) vError("fSd3: list=0");
	//return fSd3(a.r, b.r, vx, vy, list) + fSd3(a.g, b.g, vx, vy, list) + fSd3(a.b, b.b, vx, vy, list);
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + vx; yb = ya + vy;	 // (xb,yb) -   b
		double s1r = b.r.getInterp3(xb, yb) - a.r.get(xa, ya);
		double s1g = b.g.getInterp3(xb, yb) - a.g.get(xa, ya);
		double s1b = b.b.getInterp3(xb, yb) - a.b.get(xa, ya);
		S += s1r*s1r + s1g*s1g + s1b*s1b;
	}
	return S;
}
//-----------------------------------------------------------------------------
double fS1Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y)// S   
{
	double xb = x + dx, yb = y + dy;
	double t = b.r.getInterp1(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp1(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp1(xb, yb) - a.b.get(x, y);
	return t*t + tg*tg + tb*tb;
}
double fS3Pnt(matr3 &a, matr3 &b, double dx, double dy, int x, int y)// S   
{
	double xb = x + dx, yb = y + dy;
	double t = b.r.getInterp3(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp3(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp3(xb, yb) - a.b.get(x, y);
	return t*t + tg*tg + tb*tb;
}
double fS1Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y)		// S   
{
	if (tr.isNothing()) vError("fS1Pnt: tr is nothing");
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.getInterp1(xb, yb) - a.get(x, y);
	return fabs(t);
}
double fS3Pnt(matr  &a, matr  &b, CvTransf &tr, int x, int y)		// S   
{
	if (tr.isNothing()) vError("fS3Pnt: tr is nothing");
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.getInterp3(xb, yb) - a.get(x, y);
	return fabs(t);
}
double fS1Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y)		// S   
{
	if (tr.isNothing()) vError("fS1Pnt: tr is nothing");
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t  = b.r.getInterp1(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp1(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp1(xb, yb) - a.b.get(x, y);
	return (t*t + tg*tg + tb*tb);
}
double fS3Pnt(matr3 &a, matr3 &b, CvTransf &tr, int x, int y)		// S   
{
	if (tr.isNothing()) vError("fS3Pnt: tr is nothing");
	double xb, yb;
	tr.apply(x, y, xb, yb); // tr(x,y) = (xb,yb)
	double t = b.r.getInterp3(xb, yb) - a.r.get(x, y);
	double tg = b.g.getInterp3(xb, yb) - a.g.get(x, y);
	double tb = b.b.getInterp3(xb, yb) - a.b.get(x, y);
	return (t*t + tg*tg + tb*tb);
}
//-----------------------------------------------------------------------------
double fS1(matr  &a, matr  &b, CvTransf &tr, pvector &list)	// S   
{
	if (tr.isNothing()) vError("fS1: tr is nothing");
	if (list.size() == 0) vError("fS1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double s1 = b.getInterp1(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fS3(matr  &a, matr  &b, CvTransf &tr, pvector &list)	// S   
{
	if (tr.isNothing()) vError("fS3: tr is nothing");
	if (list.size() == 0) vError("fS3: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double s1 = b.getInterp3(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fS1(matr3 &a, matr3 &b, CvTransf &tr, pvector &list)	// S   
{
	if (tr.isNothing()) vError("fS1: tr is nothing");
	if (list.size() == 0) vError("fS1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double t = b.r.getInterp1(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp1(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp1(xb, yb) - a.b.get(xa, ya);
		S += t*t + tg*tg + tb*tb;
	}
	return S;
}
double fS3(matr3 &a, matr3 &b, CvTransf &tr, pvector &list)	// S   
{
	if (tr.isNothing()) vError("fS3: tr is nothing");
	if (list.size() == 0) vError("fS3: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		tr.apply(xa, ya, xb, yb); // tr(x,y) = (xb,yb)
		double t = b.r.getInterp3(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp3(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp3(xb, yb) - a.b.get(xa, ya);
		S += t*t + tb*tg + tb*tb;
	}
	return S;
}
//-----------------------------------------------------------------------------
double fSV1(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSV1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + flowCo*vx(xa, ya);
		yb = ya + flowCo*vy(xa, ya);
		double s1 = b.getInterp1(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fSV3(matr  &a, matr  &b, matr &vx, matr &vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSV1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + flowCo*vx(xa, ya);
		yb = ya + flowCo*vy(xa, ya);
		double s1 = b.getInterp3(xb, yb) - a.get(xa, ya);
		S += s1*s1;
	}
	return S;
}
double fSV1(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSV1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + flowCo*vx(xa, ya);
		yb = ya + flowCo*vy(xa, ya);
		double t = b.r.getInterp1(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp1(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp1(xb, yb) - a.b.get(xa, ya);
		S += t*t + tb*tg + tb*tb;
	}
	return S;
}
double fSV3(matr3 &a, matr3 &b, matr &vx, matr &vy, pvector &list)	// S     
{
	if (list.size() == 0) vError("fSV1: list=0");
	double S = 0, xb, yb;
	int xa, ya;
	for (int i = 0; i < list.size(); i++) {
		xa = list.getX(i);
		ya = list.getY(i);
		xb = xa + flowCo*vx(xa, ya);
		yb = ya + flowCo*vy(xa, ya);
		double t = b.r.getInterp3(xb, yb) - a.r.get(xa, ya);
		double tg = b.g.getInterp3(xb, yb) - a.g.get(xa, ya);
		double tb = b.b.getInterp3(xb, yb) - a.b.get(xa, ya);
		S += t*t + tb*tg + tb*tb;
	}
	return S;
}
//=============================================================================
//  
//=============================================================================
double flowMax(matr &vx, matr &vy)									//   
{
	int mx = vx.Mx(), my = vy.My();
	double V = 0;
	int v1;
	for (int y = 0; y < my; y++) {
		for (int x = 0; x < mx; x++) {
			v1 = iSquare(vx(x, y)) + iSquare(vy(x, y));
			if (v1 > V) V = v1;
		}
	}
	return sqrt(V*flowCo*flowCo);
}
//----------------------------------------------------------------------------
void   saveFlowBlock(matr &vx, matr &vy, int x0, int y0, int dx, int dy, char *fname)
{
	int mx = vx.Mx(), my = vy.My();
	if (x0 < 0) x0 = 0;
	if (x0 + dx>mx) dx = mx - x0;
	if (y0 < 0) y0 = 0;
	if (y0 + dy>my) dy = my - y0;

	FILE *f = fopen(fname, "w");
	fprintf(f, "Flow block (%4d,%4d)-(%4d,%4d), total size=(%4d,%4d)\n", x0, y0, dx, dy, mx, my);
	for (int y = y0; y < y0 + dy; y++) {
		for (int x = x0; x < x0 + dx; x++) {
			fprintf(f, "(%4d,%4d: %4d,%4d)", x, y, vx(x,y), vy(x,y));
		}
		fprintf(f, "\n");
	}
	fclose(f);
}
//----------------------------------------------------------------------------
//  co<0,    -co,    co
void showVxVy(matr &vx, matr &vy, char *fname, int co)	//    (vx,vy)  bmp- fname
{	//    16!
	int mx = vx.Mx(), my = vy.My();
	matr3 f(mx, my);
	int cr, cg, cb;
	for (int y = 0; y < my; y++) {
		for (int x = 0; x < mx; x++) {
			if (co < 0) {
				cr = 128 + iDivide(vx(x, y), -co);
				cg = 128 + iDivide(vy(x, y), -co);
			}
			else {
				cr = 128 + vx(x, y)*co;
				cg = 128 + vy(x, y)*co;
			}
			cb = 3 * 128 - (cr + cg);
			if (cb < 0) cb = 0;
			if (cb > 255) cb = 255;
			f.put(x, y, cr, cg, cb);
		}
	}
	f.saveBMP(fname);
}
//----------------------------------------------------------------------------
// (f0,f1) -  
// (vx,vy) -  ,   16.
// g0 = (vx,vy)(f1)
void vecApply(matr3 &f1, matr &vx, matr &vy, matr3 &g0) //    (vx,vy)  g0
{
	int mx = f1.Mx(), my = f1.My();
	g0.setSize(mx, my);
	double S = 0;
	for (int y = 0; y < my; y++) {
		for (int x = 0; x < mx; x++) {
			double x1 = x + vx(x, y) / 16.;
			double y1 = y + vy(x, y) / 16.;
			g0.r(x, y) = round(f1.r.getInterp3(x1, y1));
			g0.g(x, y) = round(f1.g.getInterp3(x1, y1));
			g0.b(x, y) = round(f1.b.getInterp3(x1, y1));
		}
	}
}
//----------------------------------------------------------------------------
double flowQ(matr3 &f0, matr3 &f1, matr &vx, matr &vy, matr &res)	// res:=  (vx,vy): f0->f1   
{
	int mx = f0.Mx(), my = f0.My();
	if (f1.Mx() != mx || f1.My() != my || vx.Mx() != mx || vx.My() != my || vy.Mx() != mx || vy.My() != my) vError("flowQ1: sizes");
	double S = 0;
	res.setSize(mx, my);
	for (int y = 0; y < my; y++)
		for (int x = 0; x < mx; x++) {
			double x1 = x + flowCo*vx(x, y);
			double y1 = y + flowCo*vy(x, y);		// (x1,y1) -  (x,y)   f1
			double r1 = f1.r.getInterp3(x1, y1);
			double g1 = f1.g.getInterp3(x1, y1);
			double b1 = f1.b.getInterp3(x1, y1);
			double dS = dSquare(f0.r(x, y) - r1) + dSquare(f0.g(x, y) - g1) + dSquare(f0.b(x, y) - b1);
			res(x, y) = round(sqrt(dS)/3);
			S += dS;
		}
	return sqrt(S / (mx*my));
}
double flowQ(matr3 &f0, matr3 &f1, matr &vx, matr &vy)			//  
{
	int mx = f0.Mx(), my = f0.My();
	if (f1.Mx() != mx || f1.My() != my || vx.Mx() != mx || vx.My() != my || vy.Mx() != mx || vy.My() != my) vError("flowQ1: sizes");
	double S = 0;
	for (int y = 0; y < my; y++)
		for (int x = 0; x < mx; x++) {
			double x1 = x + flowCo*vx(x, y);
			double y1 = y + flowCo*vy(x, y);		// (x1,y1) -  (x,y)   f1
			double r1 = f1.r.getInterp3(x1, y1);
			double g1 = f1.g.getInterp3(x1, y1);
			double b1 = f1.b.getInterp3(x1, y1);
			double dS = dSquare(f0.r(x, y) - r1) + dSquare(f0.g(x, y) - g1) + dSquare(f0.b(x, y) - b1);
			S += dS;
		}
	return sqrt(S / (3 * mx*my));
}
//-----------------------------------------------------------------------------
double flowVar(matr &vx, matr &vy, matr &res)						// res:=    
{
	int mx = vx.Mx(), my = vx.My();
	if (vx.Mx() != mx || vy.My() != my) vError("flowVar: sizes");
	double S = 0;
	res.setSize(mx, my);
	for (int y = 0; y < my; y++)
		for (int x = 0; x < mx; x++) {
			int vx0 = vx(x, y);
			int vy0 = vy(x, y);
			int d0 = vx.safeGet(x - 1, y) - vx0;
			int d1 = vx.safeGet(x + 1, y) - vx0;
			int d2 = vx.safeGet(x, y - 1) - vx0;
			int d3 = vx.safeGet(x, y + 1) - vx0;
			int dS = d0*d0 + d1*d1 + d2*d2 + d3*d3;
			res(x, y) = round(sqrt((double)dS));
			S += dS;
		}
	return sqrt(S / (3 * mx*my));
}
double flowVar(matr &vx, matr &vy)									//  
{
	int mx = vx.Mx(), my = vx.My();
	if (vx.Mx() != mx || vy.My() != my) vError("flowVar: sizes");
	double S = 0;
	for (int y = 0; y < my; y++)
		for (int x = 0; x < mx; x++) {
			int vx0 = vx(x, y);
			int vy0 = vy(x, y);
			int d0 = vx.safeGet(x - 1, y) - vx0;
			int d1 = vx.safeGet(x + 1, y) - vx0;
			int d2 = vx.safeGet(x, y - 1) - vx0;
			int d3 = vx.safeGet(x, y + 1) - vx0;
			int dS = d0*d0 + d1*d1 + d2*d2 + d3*d3;
			S += dS;
		}
	return sqrt(S / (3 * mx*my));
}
//-----------------------------------------------------------------------------
double flowAff(matr &vx, matr &vy, pvector &list, CvTransf &tr)	// tr :=   
{
	LeastSq LSx(3), LSy(3);
	int n = list.size();
	for (int i = 0; i < n; i++) {
		int x = list[i].x;
		int y = list[i].y;
		LSx.add3(1, x, y, flowCo*vx(x, y));
		LSy.add3(1, x, y, flowCo*vy(x, y));
	}
	LSx.solve();
	LSy.solve();
	double a0 = LSx.sol[0];
	double a1 = LSx.sol[1] + 1;
	double a2 = LSx.sol[2];

	double a3 = LSy.sol[0];
	double a4 = LSy.sol[1];
	double a5 = LSy.sol[2] + 1;
	tr.set(a0, a1, a2, a3, a4, a5);

	double er = 0;
	double x1, y1;
	for (int i = 0; i < n; i++) {
		int x = list[i].x;
		int y = list[i].y;
		tr.apply(x, y, x1, y1);		// (x1,y1) -  
		er += dSquare(x + flowCo*vx(x, y) - x1)
			+ dSquare(y + flowCo*vy(x, y) - y1);
	}
	er /= n;
	return sqrt(er);
}
//-----------------------------------------------------------------------------
void   setFlow(segm &sgm, int iS, CvTransf &tr, matr &vx, matr &vy)//    iS    . tr
{
	int mx = sgm.Mx(), my = sgm.My();
	if (vx.Mx() != mx || vx.My() != my || vy.Mx() != mx || vy.My() != my) vError("setFlow: sizes");
	double x1, y1;
	for (int y = 0; y < my; y++)
		for (int x = 0; x < mx; x++) {
			if (sgm(x, y) != iS) continue;		//    iS- 
			tr.apply(x, y, x1, y1);
			vx(x, y) = round(flowK*(x1 - x));
			vy(x, y) = round(flowK*(y1 - y));
		}
}
void   setFlow(pvector list, CvTransf &tr, matr &vx, matr &vy)		//       . tr
{
	double x1, y1;
	for (int i = 0; i < list.size(); i++) {
		int x = list.getX(i);
		int y = list.getY(i);
		tr.apply(x, y, x1, y1);
		vx(x, y) = round(flowK*(x1 - x));
		vy(x, y) = round(flowK*(y1 - y));
	}
}
//=============================================================================
void saveArr(double *v, int mx, int my, char *fname, char *msg="")
{
	FILE *f = aopen(fname);
	fprintf(f, "Values of S, mx=%4d, my=%4d;  %s\n", mx, my, msg);
	for (int iy = 0; iy < my; iy++) {
		fprintf(f, "%4d:", iy);
		for (int ix = 0; ix < mx; ix++) {
			fprintf(f, "%8.2f ", *v++);
		}
		fprintf(f, "\n");
	}
	fprintf(f, "-------------------------------------\n");
	fclose(f);
}
//-----------------------------------------------------------------------------
double LK0_searchI(matr3 &a, matr3 &b, pvector &list, int h, int Nh, int &vx, int &vy, char *prot)	//     h,  Nh , 
{
	if (prot) {
		double x1, y1;
		list.midPoint(x1, y1);
		hWrite(prot, "\n--------------------->(%7.2f,%7.2f)\n", x1, y1);
	}

	//setSqrt(false);					//   S    
	//setSqrt(true);						//   S      
	if (list.size()==0) vError("LK0_searchI: list.size=0");
	if (Nh < 1 || Nh>20) vError("LK0_searchI: Nh=%d", Nh);
	//  1 <= Nh <=20
	int Nh2 = 2 * Nh + 1;				// ,  3 <= Nh2 <= 41
	double *S0 = new double[Nh2*Nh2];	//    S   
	int iyMin, ixMin;
	double sMin = dbl_MAX;
	int distMin = 999999;
	for (int iy = 0; iy < Nh2; iy++) {
		int vy = h*(iy - Nh);
		for (int ix = 0; ix < Nh2; ix++) {
			int vx = h*(ix - Nh);
			double t = fSi(a, b, vx, vy, list);
			S0[ix + Nh2*iy] = t;
			int dist = iSquare(ix - Nh) + iSquare(iy - Nh);
			if (t == sMin && dist < distMin) {
				ixMin = ix;
				iyMin = iy;
				distMin = dist;
			} else
			if (t < sMin) {
				sMin = t;
				ixMin = ix;
				iyMin = iy;
				distMin = dist;
			}
		}
	}
	if (prot)
		saveArr(S0, Nh2, Nh2, prot, toString("max=%d, step=%d, min(%d,%d)=%8.1f", h*Nh, h, ixMin, iyMin, sMin));
	//   
	//   sMin   (ixMin,iyMin)
	//    3*3     [0..Nh2-1, 0..Nh2-1]
	//     (x0,y0),   :
	// 0 <= x0,y0 <= Nh2-3
	int x0 = ixMin - 1, y0 = iyMin - 1;
	if (x0 < 0) x0 = 0;
	if (x0 >= Nh2 - 3) x0 = Nh2 - 3;
	if (y0 < 0) y0 = 0;
	if (y0 >= Nh2 - 3) y0 = Nh2 - 3;
	//  (x0,y0) -     3*3
	// 0 <= x0,y0 <= Nh2-3

	double f9[9];		//     3*3   h
	f9[0] = S0[x0 + Nh2*y0]; f9[1] = S0[x0 + 1 + Nh2*y0]; f9[2] = S0[x0 + 2 + Nh2*y0];
	f9[3] = S0[x0 + Nh2*y0 + Nh2]; f9[4] = S0[x0 + 1 + Nh2*y0 + Nh2]; f9[5] = S0[x0 + 2 + Nh2*y0 + Nh2];
	f9[6] = S0[x0 + Nh2*y0 + 2 * Nh2]; f9[7] = S0[x0 + 1 + Nh2*y0 + 2 * Nh2]; f9[8] = S0[x0 + 2 + Nh2*y0 + 2 * Nh2];
	delete[]S0;			// S0   
	double ex, ey;
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("first, step=%d, E=(%7.4f, %7.4f)", h, ex, ey));
	//    :
	ex = h*(x0 + 1 - Nh + ex);
	ey = h*(y0 + 1 - Nh + ey);
	// :
	int x1 = round(ex);
	int y1 = round(ey);

	double R0 = fSi(a, b, x1, y1, list);		//  S   
	//if (R0 > f9[4]) {							//    ,   
	//	x1 = h*(x0 + 1 - Nh);
	//	y1 = h*(y0 + 1 - Nh);
	//	R0 = f9[4];
	//}
	if (R0 > sMin) {							//    ,   
		x1 = h*(ixMin - Nh);
		y1 = h*(iyMin - Nh);
		R0 = sMin;
	}
	x0 = x1; y0 = y1;

	//      :
	// (x0,y0) -     R0,
	// (x1,y1) -    R1,
	double R0old=1e99, R1;
	while (R0old > R0) {
		R0old = R0;
		for (int k = 0; k < 8; k++) {
			neighbor8(x0, y0, k, x1, y1);
			R1 = fSi(a, b, x1, y1, list);
			if (R1 >= R0) continue;
			//     k  .    
			do {
				if (prot)
					hWrite(prot, "neib, (%4d,%4d:%7.4f) -> (%4d,%4d:%7.4f)\n", x0, y0, R0, x1, y1, R1);
				x0 = x1; y0 = y1; R0 = R1;
				neighbor8(x0, y0, k, x1, y1);
				R1 = fSi(a, b, x1, y1, list);
			} while (R1<R0);
			//       !
		} //   
	}
	vx = x0; 
	vy = y0;
	return R0;
}//double LK0_searchI(matr3 &a, matr3 &b, pvector &list, int h, int Nh, int &vx, int &vy, char *prot)	//     h,  Nh , 
//-----------------------------------------------------------------------------
double LK0_optI(matr3 &a, matr3 &b, pvector &list, int &vx, int &vy, int maxV, char *prot)//     
{
	double R0old = 1e99, R0, R1;
	int vx1, vy1;
	R0 = fSi(a, b, vx, vy, list);				//  
	while (R0old > R0) {
		R0old = R0;
		for (int k = 0; k < 8; k++) {
			neighbor8(vx, vy, k, vx1, vy1);
			if (iabs(vx1) + iabs(vy1)>maxV) continue;
			R1 = fSi(a, b, vx1, vy1, list);
			if (R1 >= R0) continue;
			//     k  .    
			do {
				if (prot)
					hWrite(prot, "neib, (%4d,%4d:%7.4f) -> (%4d,%4d:%7.4f)\n", vx, vy, R0, vx1, vy1, R1);
				vx = vx1; vy = vy1; R0 = R1;
				neighbor8(vx, vy, k, vx1, vy1);
				R1 = fSi(a, b, vx1, vy1, list);
			} while (R1<R0);
			//       !
		} //   
	}
	return R0;
}// double LK0_optI(matr3 &a, matr3 &b, pvector &list, int &vx, int &vy, char *prot = NULL)//     
//-----------------------------------------------------------------------------
double LK0_optJ(matr3 &a, matr3 &b, pvector &list, int &vx, int &vy, int vx0, int vy0, int maxV, char *prot)//    + (x0,y0)  
{
	double R0old = 1e99, R0, R1;
	int lam = 1;
	int vx1, vy1;
	R0 = fSi(a, b, vx, vy, list) + lam*(iSquare(vx-vx0) + iSquare(vy-vy0));				//  
	while (R0old > R0) {
		R0old = R0;
		for (int k = 0; k < 8; k++) {
			neighbor8(vx, vy, k, vx1, vy1);
			if (iabs(vx1) + iabs(vy1)>maxV) continue;
			R1 = fSi(a, b, vx1, vy1, list) + lam*(iSquare(vx1 - vx0) + iSquare(vy1 - vy0));
			if (R1 >= R0) continue;
			//     k  .    
			do {
				if (prot)
					hWrite(prot, "neib, (%4d,%4d:%7.4f) -> (%4d,%4d:%7.4f)\n", vx, vy, R0, vx1, vy1, R1);
				vx = vx1; vy = vy1; R0 = R1;
				neighbor8(vx, vy, k, vx1, vy1);
				R1 = fSi(a, b, vx1, vy1, list) + lam*(iSquare(vx1 - vx0) + iSquare(vy1 - vy0));
			} while (R1<R0);
			//       !
		} //   
	}
	return R0;
}
//-----------------------------------------------------------------------------
double LK0_searchD(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot)//     h,  Nh , double
{
	int vxI, vyI;
	double R0 = LK0_searchI(a, b, list, h, Nh, vxI, vyI, prot);
	// (vxI, vyI) -     

	//         hD:
	double hD = 1. / 16;
	// (x0,y0) -     R0,
	// (x1,y1) -    R1,
	double x0 = vxI, y0=vyI, x1, y1;
	//y1 = fSi(a, b, vxI, vyI, list);
	//x1 = fSd1(a, b, x0, y0, list);
	int dxI, dyI;
	double R0old = R0+1e-9, R1;
	while (R0old > R0) {
		R0old = R0;
		for (int k = 0; k < 8; k++) {
			neighbor8(0, 0, k, dxI, dyI);
			x1 = x0 + hD*dxI;
			y1 = y0 + hD*dyI;
			R1 = fSd3(a, b, x1, y1, list);
			if (R1 >= R0) continue;
			//     k  .    
			do {
				if (prot)
					hWrite(prot, "neib, (%6.2f,%6.2f:%7.4f) -> (%6.2f,%6.2f:%7.4f)\n", x0, y0, R0, x1, y1, R1);
				x0 = x1; y0 = y1; R0 = R1;
				//neighbor8(0, 0, k, dxI, dyI);
				x1 = x0 + hD*dxI;
				y1 = y0 + hD*dyI;
				R1 = fSd1(a, b, x1, y1, list);
			} while (R1<R0);
			//       !
		} //   
	}
	vx = x0;
	vy = y0;
	return R0;

}//double LK0_searchD(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot = NULL);//     h,  Nh , double


// - -
//  prot,      LK0Searc2.log
void LK0_search(matr3 &a, matr3 &b, pvector &list, int h, int Nh, double &vx, double &vy, char *prot)	//     h,  Nh 
{
	//setSqrt(false);					//   S    
	//setSqrt(true);					//   S      
	int Nh2 = 2 * Nh + 1;				// 
	double *S0 = new double[Nh2*Nh2];	//    S   
	int iyMin, ixMin;
	double sMin = dbl_MAX;
	for (int iy = 0; iy < Nh2; iy++) {
		int vy = h*(iy - Nh);
		for (int ix = 0; ix < Nh2; ix++) {
			int vx = h*(ix - Nh);
			double t = fSi(a, b, vx, vy, list);
			S0[ix + Nh2*iy] = t;
			if (t < sMin) {
				sMin = t;
				ixMin = ix;
				iyMin = iy;
			}
		}
	}
	if( prot)
		saveArr(S0, Nh2, Nh2, prot, toString("max=%d, step=%d, min(%d,%d)=%8.1f", h*Nh, h, ixMin, iyMin, sMin));
	//   
	//   sMin   (ixMin,iyMin)
	//    3*3     [0..Nh2-1, 0..Nh2-1]
	//     (x0,y0),   :
	// 0 <= x0,y0 <= Nh2-3
	int x0 = ixMin - 1, y0 = iyMin - 1;
	if (x0 < 0) x0 = 0;
	if (x0 >= Nh2 - 3) x0 = Nh2 - 3;
	if (y0 < 0) y0 = 0;
	if (y0 >= Nh2 - 3) y0 = Nh2 - 3;
	//  (x0,y0) -     3*3
	// 0 <= x0,y0 <= Nh2-3

	double f9[9];		//     3*3   h
	f9[0] = S0[x0 + Nh2*y0]; f9[1] = S0[x0 + 1 + Nh2*y0]; f9[2] = S0[x0 + 2 + Nh2*y0];
	f9[3] = S0[x0 + Nh2*y0+Nh2]; f9[4] = S0[x0 + 1 + Nh2*y0 + Nh2]; f9[5] = S0[x0 + 2 + Nh2*y0 + Nh2];
	f9[6] = S0[x0 + Nh2*y0 + 2*Nh2]; f9[7] = S0[x0 + 1 + Nh2*y0 + 2 * Nh2]; f9[8] = S0[x0 + 2 + Nh2*y0 + 2 * Nh2];
	delete[]S0;			// S0   
	double ex, ey;
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("first, step=%d, E=(%7.4f, %7.4f)", h, ex, ey));
	//    :
	ex = h*(x0 + 1 - Nh + ex);
	ey = h*(y0 + 1 - Nh + ey);
	// :
	int x1 = round(ex);
	int y1 = round(ey);

	double newS = fSi(a, b, x1, y1, list);		//  S   
	if (newS > f9[4]) {							//    ,   
		x1 = h*(x0 + 1 - Nh);
		y1 = h*(y0 + 1 - Nh);
	}

	x0 = x1; y0 = y1;

	//   3*3:
	f9[0] = fSi(a, b, x0 - 1, y0-1, list); f9[1] = fSi(a, b, x0, y0-1, list); f9[2] = fSi(a, b, x0 + 1, y0-1, list);
	f9[3] = fSi(a, b, x0 - 1, y0, list); f9[4] = fSi(a, b, x0, y0, list); f9[5] = fSi(a, b, x0 + 1, y0, list);
	f9[6] = fSi(a, b, x0 - 1, y0+1, list); f9[7] = fSi(a, b, x0, y0+1, list); f9[8] = fSi(a, b, x0 + 1, y0+1, list);
	minBiSq(f9, ex, ey, 1);
	if (prot)
		saveArr(f9, 3, 3, prot, toString("second, step=1, (%d,%d)-> E=(%7.4f, %7.4f)", x0, y0, ex, ey));
	//  |ex|==1  |ey|==1     3- :
	int cnt = 3;
	double midValue = f9[4];
	while (fabs(ex) == 1 || fabs(ey) == 1) {
		// :
		x0 = round(x0+ex);
		y0 = round(y0+ey);
		//   3*3:
		f9[0] = fSi(a, b, x0 - 1, y0 - 1, list); f9[1] = fSi(a, b, x0, y0 - 1, list); f9[2] = fSi(a, b, x0 + 1, y0 - 1, list);
		f9[3] = fSi(a, b, x0 - 1, y0, list); f9[4] = fSi(a, b, x0, y0, list); f9[5] = fSi(a, b, x0 + 1, y0, list);
		f9[6] = fSi(a, b, x0 - 1, y0 + 1, list); f9[7] = fSi(a, b, x0, y0 + 1, list); f9[8] = fSi(a, b, x0 + 1, y0 + 1, list);
		if (f9[4] >= midValue - 0.01) break;
		midValue = f9[4];
		minBiSq(f9, ex, ey, 1);
		if (prot)
			saveArr(f9, 3, 3, prot, toString("third, step=1, (%d,%d)-> E=(%7.4f, %7.4f)", x0, y0, ex, ey));
		if (--cnt == 0) break;
	};
	//    :
	vx = ex + x0;
	vy = ey + y0;
}
//-----------------------------------------------------------------------------
void normaSh(int x, double &dx, int max) {
	int m16 = max >> 4;
	if (dx < -m16) dx = -m16;
	else if (dx > m16) dx = m16;
	double x1 = x + dx;
	if (x1 < 0) dx = -x;
	else if (x1>max) dx = max - x;
}
//-----------------------------------------------------------------------------
// solve:
// a0 + a1*x + a2*y = 0
// a3 + a4*x + a5*y = 0
bool solve22(double *a, double &x, double &y) {
	double det = a[1]*a[5] - a[4]*a[2];
	if (fabs(det) < 1e-8) { x = y = 0; return false; }
	det = 1 / det;
	x = (a[2] * a[3] - a[0] * a[5])*det;
	y = (a[4]*a[0] - a[1]*a[3])*det;
	return true;
}
int previous(matr &a, int x, int y) {	//     
	if (y == 0) {
		return x == 0 ? 0 : a(x - 1, 0);
	}
	// now y>0
	if (x == 0) return a(0, y - 1);
	// now x,y>0
	return (1 + a(x - 1, y) + a(x, y - 1) + a(x - 1, y - 1)) / 3;
}
int midNeib(matr &a, int x, int y, int h)	//        h
{
	int mx = a.Mx(), my = a.My();
	int cnt = 0, s = 0;
	for (int y2 = y - h; y2 <= y + h; y2+= h) {
		if (y2 < 0) continue;
		if (y2 >= my) break;
		for (int x2 = x - h; x2 <= x + h; x2+= h) {
			if (x2 < 0) continue;
			if (x2 >= mx) break;
			if (x2 == x && y2 == y) continue;
			s += a(x2, y2);
			cnt++;
		}
	}
	return iDivide(s,cnt);
}
//-----------------------------------------------------------------------------
bool LK0_uStep(matr3 &as, matr3 &bs, matr3 &bx, matr3 &by, int x, int y, double &x1, double &y1, double &mse) //     
{
	int mx = as.Mx(), my = as.My();

	int    fr = as.r(x, y);
	int    fg = as.g(x, y);
	int    fb = as.b(x, y);

	double gr = bs.r.getInterp1(x1, y1);
	double gg = bs.g.getInterp1(x1, y1);
	double gb = bs.b.getInterp1(x1, y1);

	mse = dSquare(gr - fr) + dSquare(gg - fg) + dSquare(gb - fb);

	double gxr = bx.r.getInterp1(x1, y1);
	double gxg = bx.b.getInterp1(x1, y1);
	double gxb = bx.b.getInterp1(x1, y1);

	double gyr = by.r.getInterp1(x1, y1);
	double gyg = by.b.getInterp1(x1, y1);
	double gyb = by.b.getInterp1(x1, y1);

	double q[6];				//     2*2
	double dx, dy;
	q[0] = (gr - fr)*gxr + (gg - fg)*gxg + (gb - fb)*gxb;
	q[1] = (gxr*gxr + gxg*gxg + gxb*gxb) / 2;
	q[2] = (gxr*gyr + gxg*gyg + gxb*gyb) / 2;
	q[3] = (gr - fr)*gyr + (gg - fg)*gyg + (gb - fb)*gyb;
	q[4] = q[2];
	q[5] = (gyr*gyr + gyg*gyg + gyb*gyb) / 2;
	solve22(q, dx, dy);
	dx += x1 - x;
	dy += y1 - y;
	normaSh(x, dx, mx - 1);
	normaSh(y, dy, my - 1);
	double x1_ = x + dx;
	double y1_ = y + dy;

	double mse1 = dSquare(bs.r.getInterp1(x1_, y1_) - fr) + dSquare(bs.g.getInterp1(x1_, y1_) - fg) + dSquare(bs.b.getInterp1(x1_, y1_) - fb);
	if (mse1>mse) { 
		return false; 
	}
	x1 = x1_; y1 = y1_;
	return true;
}// LK0_uStep(matr3 &as, matr3 &bs, matr3 &bx, matr3 &by, int x, int y, double &x1, double &y1, double &mse) //     
//-----------------------------------------------------------------------------
int LK0_uSteps(matr3 &as, matr3 &bs, matr3 &bx, matr3 &by, int x, int y, double &x1, double &y1, double &mse, int rep) //    .   
{
	int i;
	for (i = 0; i < rep; i++)
		if (!LK0_uStep(as, bs, bx, by, x, y, x1, y1, mse)) break;
	return i;
}
//-----------------------------------------------------------------------------
// - -
void LK0_usual(matr3 &a, matr3 &b, matr &vx, matr &vy, int rep)	// (vx,vy) :=    (a,b)   
{
	int mx = a.Mx(), my = a.My();
	int mx8 = mx / 16, my8 = my / 16;
	matr vx8(mx8, my8), vy8(mx8, my8);		//     8
	matr3 as, bs;							//  
	matr3 bx, by;							//    bs

	int co = 16;					// ,    
	int rSm = 7;					//   

	as.copyFrom(a);
	as.mult(co);
	as.smooth(rSm);

	bs.copyFrom(b);
	bs.mult(co);
	bs.smooth(rSm);
	bx.diffX(bs);					// bx := 2*db/dx 
	by.diffY(bs);					// by := 2*db/dy 

	int x, y, x8, y8;
	pvector list;
	double wx, wy;
	for (y8 = 0; y8 < my8; y8++) {
		//fprintf(stderr, " %d/%d\r", y8, my8);
		y = 8 + 16 * y8;
		for (x8 = 0; x8 < mx8; x8++) {
			x = 8 + 16 * x8;
			list.createCircleK(x, y, 20, 5, mx, my);
			LK0_searchD(as, bs, list, 8, 5, wx, wy);	//   8,  5 , (wx,wy) - 
			normaSh(x, wx, mx - 1);
			normaSh(y, wy, my - 1);

			vx8(x8, y8) = round(16 * wx);
			vy8(x8, y8) = round(16 * wy);

		}
	}
	fprintf(stderr, " 1/16 \n");
	//vx8.saveText("vx8.txt");
	//vy8.saveText("vy8.txt");
	//      
	vx.setSize(mx, my);
	vy.setSize(mx, my);
	double x1, y1, x2, y2;
	double mse1, mse2;
	int cnt1 = 0, cnt2 = 0, cnt3 = 0, cnu1 = 0, cnu2 = 0, cnu3 = 0;	//   1,2,3    
	int sum1 = 0, sum2 = 0, sum3 = 0, suu1 = 0, suu2 = 0, suu3 = 0;	//    1,2,3    
	int stp1, stp2, stp3, itp;
	//      :
	for (y = 0; y < my; y++) {
		if ((y & 15) == 15)
			fprintf(stderr, " %d/%d\r", y, my);
		double y8_ = (y - 8)*0.0625;
		for (x = 0; x < mx; x++) {
			//if (y==15 && x == 100)
			//	x1 = 0;
			double x8_ = (x - 8)*0.0625;
			wx = vx8.getInterp1(x8_, y8_) / 16.;		//    
			wy = vy8.getInterp1(x8_, y8_) / 16.;
			normaSh(x, wx, mx - 1);
			normaSh(y, wy, my - 1);
			x1 = x + wx;
			y1 = y + wy;
			cnt1++;
			stp1=LK0_uSteps(as, bs, bx, by, x, y, x1, y1, mse1, rep);
			sum1 += stp1;
			itp = 1;
			if (rep > 1) {
				//    
				x2 = x + previous(vx, x, y) / 16.;
				y2 = y + previous(vy, x, y) / 16.;
				cnt2++;
				stp2 = LK0_uSteps(as, bs, bx, by, x, y, x2, y2, mse2);
				sum2 += stp2;
				if (mse2 < mse1) { x1 = x2; y1 = y2; mse1 = mse2; itp = 2; }

				//    
				x2 = x;
				y2 = y;
				cnt3++;
				stp3 = LK0_uSteps(as, bs, bx, by, x, y, x2, y2, mse2);
				sum3 += stp3;
				if (mse2 < mse1) { x1 = x2; y1 = y2; mse1 = mse2; itp = 3; }
			}
			//  :
			vx(x, y) = round(16 * (x1-x));
			vy(x, y) = round(16 * (y1-y));

			if (itp == 1) {
				cnu1++;
				suu1 += stp1;
			};
			if (itp == 2) {
				cnu2++;
				suu2 += stp2;
			};
			if (itp == 3) {
				cnu3++;
				suu3 += stp3;
			};
		}
	}
	//printf("mid     1,2,3 = %8.4f,%8.4f,%8.4f\n", ((double)sum1) / cnt1, ((double)sum2) / cnt2, ((double)sum3) / cnt3);
	//printf("cnt_opt 1,2,3 = %8d,%8d,%8d\n", cnu1, cnu2, cnu3);
	//printf("mid_opt 1,2,3 = %8.4f,%8.4f,%8.4f\n", ((double)suu1) / cnu1, ((double)suu2) / cnu2, ((double)suu3) / cnu3);
}



//=============================================================================
class LK1 : public MathFunc {
public:
	int n;
	matr3 *a, *b;		//  
	pvector *list;		//   
	int cx, cy, r;		//     
	dvect min, max;		//      
	pvector *v;
	double  epsX;		//     
	double  epsF;		//     
public:
	LK1();				// 
	LK1(int n_);		// 
	double operator () (dvect &);
	int N() { return n; }
	void setMatr(matr3 &f0, matr3 &f1);
	void setSegm(pvector &l);
	void setLimits(double max01, double max2, double max3, double max45 = 0);	//    
	void setEps(double epsX_, double epsF_);	//     x   F
	double minCrd(dvect &v, char *prot = NULL);
	double minCr2(dvect &v, char *prot = NULL);
	double minGrd(dvect &v, char *prot = NULL);
};
//-----------------------------------------------------------------------------
LK1::LK1()				// 
{
	epsX = 1. / 16;		//     
	epsF = 1. / 16;		//     
	n = 6;				//  
	counter = 0;
}
//-----------------------------------------------------------------------------
LK1::LK1(int n_)			// 
{
	LK1();
	if (n_ == 6) n = 6;//  
}
//-----------------------------------------------------------------------------
double LK1::operator () (dvect &v) {
	if (v.size() != 4 && v.size() != 6) vError("LK0: size =%d", v.size());
	counter++;
	CvTransf tr;
	tr.decode6(cx, cy, r, &v[0]);
	//tr.save("trd.txt");
	double res = fS3(*a, *b, tr, *list);
	return res;
}
//-----------------------------------------------------------------------------
void LK1::setMatr(matr3 &f0, matr3 &f1)
{
	this->a = &f0;
	this->b = &f1;
}
void LK1::setSegm(pvector &l)
{
	this->list = &l;
	double x, y;
	r = round(l.midPoint(x, y));
	cx = round(x);
	cy = round(y);
}
//    
void LK1::setLimits(double max01, double max2, double max3, double max45)
{
	if (max45 == 0) { min.setSize(4); max.setSize(4); n = 4; }
	else { min.setSize(6); max.setSize(6); n = 6; }
	min[0] = -max01; max[0] = max01;
	min[1] = -max01; max[1] = max01;
	min[2] = -max2;  max[2] = max2;
	min[3] = -max3;  max[3] = max3;
	if (max45 > 0) {
		min[4] = min[5] = -max45;  max[4] = max[5] = max45;
	}
}
void LK1::setEps(double epsX_, double epsF_)	//     x   F
{
	epsX = epsX_;
	epsF = epsF_;
}
//-----------------------------------------------------------------------------
double LK1::minCrd(dvect &v, char *prot)
{
	if (prot) setProt(prot);
	return this->minCoord(v, min, max, epsX, epsF);
}
double LK1::minCr2(dvect &v, char *prot)
{
	if (prot) setProt(prot);
	return this->minCoor2(v, min, max, epsX, epsF);
}
double LK1::minGrd(dvect &v, char *prot)
{
	if (prot) setProt(prot);
	return this->minGrad(v, min, max, epsX, epsF);
}
//-----------------------------------------------------------------------------
static char *LK_prot = NULL;
void IsProtU(char *prot)		// /      
{
	LK_prot = prot;
}
//-----------------------------------------------------------------------------
double LK5_opt(matr3 &f0, matr3 &f1, pvector &list, CvTransf &tr)	//    tr   list
{
	// :
	if (list.size() <4) vError("LK5_opt: list.size=%d", list.size());
	int mx = f0.Mx(), my = f0.My();
	for (int i = 0; i < list.size(); i++) {
		int x = list.getX(i);
		int y = list.getY(i);
		if (x<0 || x >= mx || y<0 || y >= my) vError("LK5_opt: (x,y)=(%d,%d) max=(%d,%d)", x, y, mx, my);
	}
	double min;						// ,  
	double cx, cy, r;				//    
	r = list.midPoint(cx, cy);
	int icx = (int)cx, icy = (int)cy, ir = 1 + (int)r;

	LK1 lk(6);											// lk -   LK1
	lk.setMatr(f0, f1);

	lk.setSegm(list);
	double maxV = (mx + my) / 40;						//  
	double max2 = r / 5;								//    ~pi/5
	//LK1::setLimits(double max01, double max2, double max3, double max45)
	lk.setLimits(maxV, max2, 2, 1);
	lk.setEps(1. / 64, 0.001);
	int n = lk.N();		//  6

	if (LK_prot) {
		//fileClear(LK_prot);
		hWrite(LK_prot, "size=(%4d,%4d), segm.size=%7d, Center(segm)=(%6.1f,%6.1f), R(segm)=%6.1f\n", mx, my, list.size(), cx, cy, r);
		hWrite(LK_prot, "Base affine:\n");
		tr.save(LK_prot);
		hWrite(LK_prot, "Steps of 6-dim optimization:\n");
	}

	dvect v(n);
	tr.code6(cx, cy, r, &v[0]);
	min = lk.minCr2(v, LK_prot);			//    
	//min = lk.minCrd(v, LK_prot);			//   
	//min = lk.minGrd(v, LK_prot);			//    
	tr.decode6(cx, cy, r, &v[0]);
	if (LK_prot) {
		hWrite(LK_prot, "Result affine:\n");
		tr.save(LK_prot);
	}
	return sqrt(min/(list.size()*3));
}
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------

