// vUtil.h: general functions and data
// (c) Khashin S.I.  khash2@gmail.com
//
//////////////////////////////////////////////////////////////////////
#ifdef VUTIL
#error Secondary include
#endif
#define VUTIL

#pragma once
#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

//typedef long double ldouble;
typedef double ldouble;

typedef unsigned char      BYTE;
typedef          long long i64;
typedef unsigned long long u64;

void    vError(const char *format, ...);		// show error function
void    vShow (const char *format, ...);		// show function
void	hWrite(const char *fname, const char *format, ... ); //   fname,     msg   

//-----------------------------------------------------------------------------
// string funtions
u64  atou64(const char *s);		//    VS2010  atoll
char *	int2str ( char* format, int x );		// x.toString()
char *	toString( const char* format, ... );
char *	toString2(const char* format, ... );
char *	copyString( const char *s );			//    
char *	nextToken( char *s );
const char *FirstWord(const char *src, const char *brk,  char *dst);	// dst:=1- ,    brk,     

inline bool isRus ( char ch){ return( ch>='' && ch<='' ); };							// ?  
inline bool isLat  (char ch){ return( (ch>='A' && ch<='Z')||(ch>='a' && ch<='z')); };	// ?  
inline bool isDig  (char ch){ return( ch>='0' && ch<='9'); };							// ? 
inline bool isLRus (char ch){ return( ch>='' && ch<=''); };							// ?   
inline bool islRus (char ch){ return( ch>='' && ch<=''); };							// ?   
inline bool isBlank(char ch) { return(ch == ' ' || ch == '\t' || ch == '\n' || ch == '\r'); };	// ? ' ', '\t', '\n', '\r'
inline bool isPnt  (char ch) { return(ch == '.' || ch == '!' || ch == '?'); };			// ? '.!?'

#define chrKind_REST		1
#define chrKind_DIGIT		2
#define chrKind_RUS			3
#define chrKind_LAT			4
#define chrKind_PNT			5
int  chrKind(char ch);	//  

bool isOnlylRus( char *s);		//      ?

//  
unsigned char  char_866_1251 (unsigned char ch);	// dos    -> win
unsigned char  char_Koi8_1251(unsigned char ch);	// koi8-r -> win
unsigned char  char_utf8_1251(unsigned char *&s);	// uft8   -> win,   , s0    

inline char  char_866_1251(char ch) { return (char)char_866_1251((unsigned char)ch);}
inline char  char_Koi8_1251(char ch) { return (char)char_Koi8_1251((unsigned char)ch); }
inline char  char_utf8_1251(char *&s) { return (char)char_utf8_1251((unsigned char * &)s); }

//  
unsigned char* cnv1251_866(unsigned char *s);		// win    -> dos  (in place)
unsigned char* cnv866_1251(unsigned  char *s);		// dos    -> win  (in place)
unsigned char* cnvKoi8_1251(unsigned char *s);		// koi8-r -> win  (in place)
unsigned char* cnv_utf8_1251(unsigned char *s);		// uft8   -> win  (in place)

inline char* cnv1251_866(char *s) { return (char *)cnv1251_866((unsigned char*)s); }
inline char* cnv866_1251(char *s) { return (char *)cnv866_1251((unsigned char*)s); }
inline char* cnvKoi8_1251(char *s) { return (char *)cnvKoi8_1251((unsigned char*)s); }
inline char* cnv_utf8_1251(char *s) { return (char *)cnv_utf8_1251((unsigned char*)s); }

													//    
#define rCP_unknown		0
#define rCP_1251		1
#define rCP_866			2
#define rCP_koi8r		3	// cp 20866
#define rCP_utf8		4
int rCodePage(unsigned char *s);//    
inline int rCodePage(char *s) { return rCodePage((unsigned char*)s); }

void ltrim(char *s);			//     
void rtrim(char *s);			//     
void trim (char *s);			//       

char* toLatLow(char *txt);		//    
char* toRusLow(char *txt);		//         
char* toRusLowP(char *txt);		//       ,   
char* txtPress(char *txt);		// trim +      

//-----------------------------------------------------------------------------
// int funtions
const   int million = 1000000;
const   int billion = 1000000000;
const   u64 p2_30 = 1 << 30;
const   u64 p2_32 = p2_30 << 2;

int		iDivide( int a, int b );	// round(a/b)
int		mod    ( int a, int b );	// math: a mod b
int		iround ( int x, int k );	//     k
int		iSquare( int x );			// x*x
BYTE	clip256( int x );			//  0   0,  255  255.
int		ilog2(unsigned x);			//   2, <= x, ilog2(0)=ilog2(1)=0, ilog2(2)=ilog2(3)=1, ...
int		ilog2(u64 x);				//   2, <= x, ilog2(0)=ilog2(1)=0, ilog2(2)=ilog2(3)=1, ...
void	swapInt( int    &a, int    &b);
u64     binomial( int n, int k );	// n! / (k!*(n-k)!, binomial(3,2)=3
int     toNatural(int x);			// map signed x to positive integer   0,1,2, ... -> 0, 2, 4, ...,  -1,-2, ... -> 1, 3, ....
int     fromNatural(int x);			// remap positive x to signed integer
inline bool odd(int x) { return x & 1; }
inline int  iabs(int x) { return x >= 0 ? x : -x; }
// max/min
int     imax2( int a, int b );
int     imax3(int a, int b, int c);
int     imax4(int a, int b, int c, int d);
int     imin2( int a, int b );
int     imin3( int a, int b, int c );
int     imin4(int a, int b, int c, int d);

int     imax(int N, int *a, int &k);	//    a[0..N-1], k -    
int     imin(int N, int *a, int &k);	//     a[0..N-1], k -    

void	corrMinMax(int x, int &min, int &max);	//    

void	iShiftR(int N, int *a);			//   : a[0]->a[1]->...->a[N-1]->a[0]
void	iShiftL(int N, int *a);			//    : a[0]<-a[1]<-...<-a[N-1]<-a[0]
int		byteAdd(int a, int b);			//    
int     quantil ( int k, unsigned *hist, int p ); //   hist  k   p
int     quantilr( int k, unsigned *hist, int p ); //   hist  k    p

bool    even64(u64 x);
bool    odd64(u64 x);

//-----------------------------------------------------------------------------
// ldouble funtions
#define dPi    3.14159265358979324
#define	TwoPi  6.28318530717958648
#define macheps (2.2e-16)					//   double
#define dbl_MAX (9e+307)					// 2*dbl_MAX = #inf
#define round(x) ((int)floor((x)+0.5 )) 	//   
ldouble	dSquare(ldouble x);
ldouble	noise2psnr( ldouble x );			// 20*log10(255/x)
ldouble	psnr2dfd  ( ldouble x );			// 255/exp(0.1151*x)
void    swapDbl( ldouble &a, ldouble &b);
ldouble  angle( ldouble x,   ldouble y);			 //  (0..2Pi)  (x,y)   X.
ldouble  hypot2( ldouble x1, ldouble x2            );// sqrt(x1*x1+x2*x2);
ldouble  hypot3( ldouble x1, ldouble x2, ldouble x3);// sqrt(x1*x1+x2*x2+x3*x3);
// max/min
ldouble  dmax2( ldouble a, ldouble b );
ldouble  dmax3(ldouble a, ldouble b, ldouble c);
ldouble  dmax4(ldouble a, ldouble b, ldouble c, ldouble d);
ldouble  dmin2( ldouble a, ldouble b );
ldouble  dmin3( ldouble a, ldouble b, ldouble c );
ldouble  dmin4(ldouble a, ldouble b, ldouble c, ldouble d);
void    dblSort3( ldouble &a, ldouble &b, ldouble &c); // make: a <= b <= c

bool    isMultiple(ldouble a, ldouble b, ldouble eps);	// a -  b    eps
int     nDigits(ldouble x);	//    
//      
// vectors of ldouble
void   vdbl_set  (int N, ldouble *a, ldouble  k);			// a[i] = k
void   vdbl_add  (int N, ldouble *a, ldouble *b);			// A += B
void   vdbl_cop  (int N, ldouble *a, ldouble *b);			// A := B
void   vdbl_mul  (int N, ldouble *a, ldouble  k);			// A *= k
void   vdbl_div  (int N, ldouble *a, ldouble  k);			// A /= k
void   vdbl_addmul(int N,ldouble *a, ldouble *b, ldouble k);// A += k*B
ldouble vdbl_len2 (int N, ldouble *a);						// |A|^2
ldouble vdbl_len  (int N, ldouble *a);						// |A|
void    vdbl_norm (int N, ldouble *a);						// |A| := 1
ldouble vdbl_dist2(int N, ldouble *a, ldouble *b);			// |A-B|^2
ldouble vdbl_dist (int N, ldouble *a, ldouble *b);			// |A-B|
ldouble vdbl_sprod(int N, ldouble *a, ldouble *b);			// scalar product(A,B)
ldouble vdbl_max  (int N, ldouble *a, int  &ind);			// maximal value and its index
ldouble vdbl_min  (int N, ldouble *a, int  &ind);			// minimal value and its index
void    vdbl_maxK (int N, ldouble *a, int K, int *I);		//   a  N      I  K  

//  () .   x        <= maxQ
// Continued fraction
ldouble chainFract(ldouble x, i64 &p, i64 &q, i64 maxQ); // optimal rat.approx p/q of x, q<=maxQ, return tolerance
//-----------------------------------------------------------------------------
// files
bool	fileExist( const char *fileName );	//    
void	fileClear( const char *fileName );	//  
int		fileSize ( const char *fileName );	//  
const char*fileExt(const char *fileName );  //  	
void	chExt(char *fileName, const char *ext);	//     ext
int		NLines(const char *fileName);		//     
int		NLines1(const char *fileName);		//      
#ifdef	_INC_STDIO							//   <stdio.h>
FILE   *aopen(const char *fname);			//  ( )    
#endif
bool	writeFile(const char *fname, const BYTE *buf, unsigned bsize);	//    
BYTE   *fileRead(const char *fname, unsigned &fsize);//      (      ). 

int		iCadr( char *s );					//      
											//  
											// char fname[64] = "c:\\a\\frame\f_0234.bmp";
											// int k = iCadr(fname);
											//  k   234.
void	nextFname(char *s);					//   
											//   next(fname);
											//  fname   "c:\\a\\frame\f_0235.bmp";

//-----------------------------------------------------------------------------
// time
long long getMillisec();				// number of milliseconds since ....
ldouble	getSec();						// number of seconds since ....
//     
#ifdef _WIN32
i64 TimerCounter();						//  
i64 TimerFrequency();					//   
#endif
//-----------------------------------------------------------------------------
// random
void     hRandomize(unsigned init=0);		// it init=0 then initialization by time
u64		 hRandom_next();					//   
int      hRandom(unsigned k);				// int random 0..k-1
ldouble  hRand();							// random 0..1
ldouble  hRand_Std();						// ...  (m=0, s=1)
ldouble  hRand_Normal(ldouble m, ldouble s);// ... .=m, ..=s
unsigned Mnext( unsigned N, unsigned x);	//   0..N-1   
//

//-----------------------------------------------------------------------------
// rest
void	copyBuf( int *dst, int stepDst, int *src, int stepSrc, int size );
void	nextPoint( int &x, int &y );	//      

void	rgb_yuv( int  r, int  g, int  b, int &y, int &u, int &v );
void	yuv_rgb( int &r, int &g, int &b, int  y, int  u, int  v );
int     rgb_int( int r, int g, int b );					// (r,g,b) -> x
void    int_rgb( int x, int &r, int &g, int &b);		// x -> (r,g,b)


void    length1( int &x, int &y);       //   (x,y)   [-1,0,1]

void neighbor (int x, int y, int k, int &x1, int &y1, int h=1);	//    k=0|1|2|3   h
void neighbor8(int x, int y, int k, int &x1, int &y1, int h=1);	//    k=0..7   h


bool boxBord(int x0, int y0, int dx, int dy, int x1, int y1);	//    <x1,y1>   
void boxNext(int x0, int y0, int dx, int dy, int &x1, int &y1);	// <x1,y1> -      
void boxPrev(int x0, int y0, int dx, int dy, int &x1, int &y1);	// <x1,y1> -      


//-----------------------------------------------------------------------------
